<?php

/**
 * Plugin Name: Wordpress AI Writer
 * Plugin URI: https://www.lyustu.com
 * Description: Create an AI Writer to your users.
 * Version: 1.0.0
 * Author: Neo Yang
 * Author URI: https://www.lyustu.com
 * Text Domain: themoon
 * Domain Path: /languages/
 * Licence: GPLv3
 *
 *[tm_aiwriter agent=xxxxx[prompt] tip=xxx save=true status=publish cat=1 default_user=1]
 */
if (!defined('ABSPATH')) {
    exit;
}
require "functions.php";
require "pagemeta.php";

add_action('wp_enqueue_scripts', 'tm_aiwriter_scripts');
function tm_aiwriter_scripts()
{
    wp_enqueue_script("jquery");
    // wp_enqueue_script("fieldsjs",get_template_directory_uri()."/formengine/fields.js");
    global $tm_nonce;
    $tm_nonce = wp_create_nonce('wp_rest');
    wp_localize_script('jquery', 'wp', [
        'nonce' => $tm_nonce,
    ]);
}

if (is_admin()) {

    add_action('admin_menu', 'tm_create_aiwriter_menu');
}

function tm_create_aiwriter_menu()
{
    add_menu_page('aiwriter', 'AI Writer', 'manage_options', 'aiwriter', 'tm_aiwriter_page');
    // add_submenu_page('aiwriter', 'Titile to Article', 'Titile to Article', 'manage_options', 'aiwriter_t2a', 'tm_aiwriter_tta_page', 10);
    // add_submenu_page('aiwriter', 'Keyword to Article', 'Keyword to Article', 'manage_options', 'aiwriter_k2a', 'tm_aiwriter_k2a_page', 10);
    //    add_submenu_page('aiwriter', 'License', 'License', 'manage_options', 'aiwriter_license', 'tm_aiwriter_license_page', 10);

    add_action('admin_init', 'tm_register_aiwriter_settings');
}

function tm_register_aiwriter_settings()
{
    // register_setting('tm-aiwriter-group', 'tm_aiwriter_pw');
    register_setting('tm-aiwriter-group', 'tm_ggai_apikey');
}
function tm_aiwriter_page()
{ ?>
    <div class="wrap">

        <h2>AI Writer Setting</h2>
        <p>v1.0.0</p>

        <p>Developed by <a href="https://www.lyustu.com" target="_blank">www.lyustu.com</a>.</p>
        <form method="post" action="options.php">

            <?php settings_fields('tm-aiwriter-group'); ?>
            <?php do_settings_sections('tm-aiwriter-group'); ?>


            <div class="section">
                <table class="form-table">

                    <tr valign="top">
                        <th scope="row"><?php _e('Google AI APIkey:', 'themoon'); ?></th>

                        <td>

                            <input name="tm_ggai_apikey" id="tm_ggai_apikey" value="<?php echo esc_attr(get_option('tm_ggai_apikey')); ?>">

                            <p style="color: #959595; display:inline">*
                                <?php _e('You can change it anytime.', 'themoon'); ?><a href="https://www.lyustu.com/en/google-gemini/" target="_blank">How to get Google AI APIkey?</a></p>
                        </td>
                    </tr>
                </table>
            </div>


    </div>
    <?php submit_button(); ?>

    </form>
    <?php wp_enqueue_script("jquery");  ?>
    <script>
        jQuery(document).ready(function($) {
            RESPONSIVEUI.responsiveTabs();
            if ($("input[name=post_meta]").attr('checked')) {
                $("#section_meta_list").addClass("hide");
            }
        });
    </script>
    </div>
<?php }







function tm_aiwriter($atts = [], $content = null, $tag = '')
{
    // normalize attribute keys, lowercase
    $atts = array_change_key_case((array) $atts, CASE_LOWER);

    // override default attributes with user attributes
    $occ_atts = shortcode_atts([
        'agent' => '',
        'tip' => 'prompt',
        'save' => '',
        'status' => '',
        'cat' => '',
        'default_user' => ''

    ], $atts, $tag);

    $path = plugins_url('', __FILE__);
    $url =   $path . "/static/aiwriter.js";
    $cssurl = $path . '/static/css/uikit.min.css';
    wp_enqueue_script("aiwriter", $url, false, "1.0");


    wp_enqueue_style('ukcss', $cssurl);

    /*  $args = array(
        'numberposts' => 12
    );

    $posts = get_posts($args); 
    $posthtml = "";
    foreach ($posts as $k => $v) {
        $url = get_permalink($v->ID);
        $posthtml = $posthtml . '<div><div class="uk-card uk-card-default uk-card-body">
      <h3 class="uk-card-title"><a href="' . $url . '">' . $v->post_title . '</a></h3>
      <p>' . get_the_excerpt($v->ID) . '</p>
  </div></div>';
    }*/
    $pointurl = home_url() . '/wp-json/tm/v1/aiwriter';

    if (is_user_logged_in()) {
        $userid = get_current_user_id();
    } else {
        $userid = "false";
    }
    $page_id = get_queried_object_id();
    $page_meta = get_post_meta($page_id, "tm_aiwriter_page_meta", true);
   /*  if(empty($page_meta["label"])){
        $page_meta["label"]="Prompt";
    }
    echo $page_meta["label"]; */
    $res = '

    <div class="uk-container">
        <fieldset class="uk-fieldset uk-text-left">

            <div class="uk-margin">
                <div class="uk-form-label">'.$page_meta["label"].'</div>
                <div class="uk-form-controls">

                    <textarea class="uk-textarea" style="height:auto;" rows="5" placeholder="'.$page_meta["label"].'" aria-label="Textarea" id="prompt"></textarea>
                </div>
            </div>
           
            <div class="uk-margin">
                <input type="hidden" value="'.$page_id.'" id="page_id">
                    <button class="uk-button uk-button-primary" id="" onclick=tm_aiwriter("' . $userid . '","' . $pointurl . '")>Generate</button>

                <p id="aiwriter_tips"></p>
            </div>
            <hr />
            <div class="uk-margin">
                <div class="uk-tile uk-text-left uk-padding-small" id="aigccontent" style="border: 1px solid #CCCCCC;">Genetated</div>
            </div>
            <div class="uk-margin uk-text-right">
                <button class="uk-button uk-button-default" onclick="tm_aiwriter_copyText(tm_aiwriter_selectText(\'aigccontent\'))">Copy</button>
 
            </div>
            <div class="uk-margin uk-text-right uk-text-meta">
Power by <a href="https://www.lyustu.com/" target="_blank" class="uk-text-meta" title="Wordpress AI Writer">lyustu.com Wordpress AI Writer</a>
        </div>

        </fieldset>
    </div>
    <div class="uk-overlay uk-position-cover" style="width:100%;height:100%;z-index:2000 !important; " id="tmaiwriterspinner" hidden>
        <div class="uk-position-center uk-tile uk-padding-small  ">
            <span uk-spinner=""></span><?php _e("Loading...Just a moment.", "themoon"); ?>
        </div>
    </div>




     ';/*  <div class="uk-margin">
            <label class="uk-form-label" for="form-stacked-select">Select Language</label>
            <div class="uk-form-controls uk-width-small">
                <select class="uk-select" id="language"> word
                    <option value="" selected>Same as prompt</option>
                    <option value="english" >English</option>
                    <option value="spanish">español</option>
                    <option value="simplified chinese">简体中文</option>
                    <option value="traditional chinese">繁体中文</option>
                    <option value="german">Deutsch</option>
                    <option value="italian">Italiano</option>
                    <option value="japanese">日本語</option>
                    <option value="korean">한국인</option>
                    <option value="portuguese">Português</option>
                    <option value="russian">Русский</option>
                    <option value="arabic">العربية</option>
              


                </select>
            </div>
        </div><textarea class="uk-textarea" style="height:auto;"  rows="15" placeholder="generated" aria-label="Textarea" "></textarea>
 */
    return $res;
}
function tm_aiwriter_shortcode()
{
    add_shortcode('tm_aiwriter', 'tm_aiwriter');
}

add_action('init', 'tm_aiwriter_shortcode');
